import React, { Component } from 'react'
import './Game.css'

class Game extends Component {
    constructor(props) {
        super(props);
        this.state = {
            number: Math.floor(Math.random() * 999) + 0,
            guess: null,
            hints: '', 
            count: 0,
            time: 60,
            color: "#fefefa"
        };
        this.timerTick = this.timerTick.bind(this);
    }
    timerTick() {
        this.timer = setInterval(
            () => {
                if (this.state.time > 0 && this.state.guess !== this.state.number) {
                    this.setState({
                        time: this.state.time - 1
                    })
                } else {
                    this.setState({ hints: 'Time is up! Please play again!' });
                    clearInterval(this.timer)
                    setTimeout(() => {
                        window.location.reload();
                    }, 5000);
                }
            },
            1000
        )
    }

    componentDidMount() {
        
    }
    componentWillUnmount() {
        console.log("Timer", "componentWillUnmount");   
        
    }
    shouldComponentUpdate() {
        return true;
    }
    componentDidUpdate() {

    }
    Guesses = (e) => {
        e.preventDefault();

        const { guess, number, time } = this.state;

        if (guess < number && time > 0) {
            this.setState({ hints: 'That guess what too low, try again!' });
            this.setState({
                count: this.state.count + 1
            });
        } else if (guess > number && time > 0) {
            this.setState({ hints: 'That guess was too high, try again!' });
            this.setState({
                count: this.state.count + 1
            });
        } else if (time > 0 && guess === number) {
            this.setState({ hints: 'Congratulations! You won the game!' });
            clearInterval(this.timer)
            setTimeout(() => {
                window.location.reload();
            }, 5000);
            
        } else {
            this.setState({ hints: 'Please enter a valid number!' });
            this.setState({
                count: this.state.count + 1
            });
        }
        this.setState({ guess: null });
    };

    render() {
        const { guess, hints, count } = this.state;
        var timerCount = this.state.time.toLocaleString();
        
        return (
            <div className="App">
                <form onSubmit={this.Guesses}>
                    <label>Enter Your Guess Here: </label>
                        <input
                            type="number" value={guess || ''} onChange={(e) => this.setState({ guess: parseInt(e.target.value) })}
                        />
                    <button type="submit">Submit</button>
                </form>
                <div class="timer">
                    <div class="number" style={{ color: this.state.color }}>
                        {timerCount}
                        <button type="submit" class="button" onClick={this.timerTick}>Start the Timer!</button>
                    </div>
                </div>
                <p class="p">You have made <b>{count}</b> guesses!</p>
                <p>{hints}</p>
            </div>
        );
    }
}

export default Game;
